题 Python当我发现异常时,如何获取类型,文件和行号?


捕获将打印如下的异常:

Traceback (most recent call last):
  File "c:/tmp.py", line 1, in <module>
    4 / 0
ZeroDivisionError: integer division or modulo by zero

我想将其格式化为:

ZeroDivisonError, tmp.py, 1

172
2017-08-14 16:02


起源


使用内置 追溯 模块。 - Ned Deily
打印代码行也可能有帮助,例外情况发生在哪里:参见 stackoverflow.com/questions/14519177/... - Apogentus


答案:


import sys, os

try:
    raise NotImplementedError("No error")
except Exception as e:
    exc_type, exc_obj, exc_tb = sys.exc_info()
    fname = os.path.split(exc_tb.tb_frame.f_code.co_filename)[1]
    print(exc_type, fname, exc_tb.tb_lineno)

265
2017-08-14 16:09



将sys.exc_info()解压缩到局部变量时应该小心,因为如果在except处理程序中得到异常,则本地变量可以保存在循环引用中而不是GC'd。最佳做法是始终只使用sys.exc_info()中的切片。或者使用其他模块,如追溯,正如其他海报所建议的那样。 - Daniel Pryden
这是线程安全的吗? - RobM
@Basj:使用sys.exc_info()[0] .__ name__,您将获得该类型的简单名称。 - Johannes Overmann
@DanielPryden Python文档也使用相同的解包方法 docs.python.org/2/library/traceback.html#traceback-examples - user
@RobM:是的,它是线程安全的。 sys.exc_info() 是为了解决以前API中的线程安全问题而引入的。其输出特定于当前线程和当前堆栈帧。 - user2357112


资源 (Py v2.7.3)for traceback.format_exception() 和被叫/相关功能有很大帮助。令人尴尬的是,我总是忘记 阅读来源。在我徒劳地寻找类似的细节后,我才这样做了。一个简单的问题,“如何为异常重新创建与Python相同的输出,具有所有相同的细节?”无论他们想要什么,这都可以让任何人获得90 +%。沮丧,我想出了这个例子。我希望它能帮助别人。 (它确实帮助了我!;-)

import sys, traceback

traceback_template = '''Traceback (most recent call last):
  File "%(filename)s", line %(lineno)s, in %(name)s
%(type)s: %(message)s\n''' # Skipping the "actual line" item

# Also note: we don't walk all the way through the frame stack in this example
# see hg.python.org/cpython/file/8dffb76faacc/Lib/traceback.py#l280
# (Imagine if the 1/0, below, were replaced by a call to test() which did 1/0.)

try:
    1/0
except:
    # http://docs.python.org/2/library/sys.html#sys.exc_info
    exc_type, exc_value, exc_traceback = sys.exc_info() # most recent (if any) by default

    '''
    Reason this _can_ be bad: If an (unhandled) exception happens AFTER this,
    or if we do not delete the labels on (not much) older versions of Py, the
    reference we created can linger.

    traceback.format_exc/print_exc do this very thing, BUT note this creates a
    temp scope within the function.
    '''

    traceback_details = {
                         'filename': exc_traceback.tb_frame.f_code.co_filename,
                         'lineno'  : exc_traceback.tb_lineno,
                         'name'    : exc_traceback.tb_frame.f_code.co_name,
                         'type'    : exc_type.__name__,
                         'message' : exc_value.message, # or see traceback._some_str()
                        }

    del(exc_type, exc_value, exc_traceback) # So we don't leave our local labels/objects dangling
    # This still isn't "completely safe", though!
    # "Best (recommended) practice: replace all exc_type, exc_value, exc_traceback
    # with sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]

    print
    print traceback.format_exc()
    print
    print traceback_template % traceback_details
    print

在具体回答此查询:

sys.exc_info()[0].__name__, os.path.basename(sys.exc_info()[2].tb_frame.f_code.co_filename), sys.exc_info()[2].tb_lineno

37
2018-04-16 20:55



@thatjuan:43行,而不是50.这包括我的无偿间距和丰富的笔记......除非你真的很高兴它只有“50”,在这种情况下它可以被制作成“更短”......? :> - pythonlarry


以下是显示异常发生位置的行号的示例。

import sys
try:
    print(5/0)
except Exception as e:
    print('Error on line {}'.format(sys.exc_info()[-1].tb_lineno), type(e).__name__, e)

print('And the rest of program continues')

20
2018-01-13 19:29





最简单的形式对我有用。

import traceback

try:
    print(4/0)
except ZeroDivisionError:
    print(traceback.format_exc())

产量

Traceback (most recent call last):
  File "/path/to/file.py", line 51, in <module>
    print(4/0)
ZeroDivisionError: division by zero

Process finished with exit code 0

15
2017-12-05 17:10



虽然不完全是操作所需的格式,但这是最简单,最强大的解决方案 - cs_alumnus